﻿Procedure ImageToColor(image, newcolor)
  Protected w, h, x, y, v, gray
  w = ImageWidth(image)
  h = ImageHeight(image)
  StartDrawing(ImageOutput(image))
  For x = 0 To w - 1
    For y = 0 To h - 1
      gray = Point(x, y)
      Plot(x, y, newcolor)
    Next
  Next
  StopDrawing()
EndProcedure

Procedure draw_round_gauge_lined(parent_canvas, value.f, units_text$="n/a",fntcol = 0, iconimg = -1, bgcol = 0,barcol = 0, min.f = -50, max.f = 50, decimals = 0, segments.f = 18)
  If StartVectorDrawing(CanvasVectorOutput(parent_canvas))
    ScaleCoordinates(DesktopResolutionX(), DesktopResolutionY())
    AddPathBox(0, 0, GadgetWidth(parent_canvas), GadgetHeight(parent_canvas))
    VectorSourceColor(RGBA(255,255,255,255))  
    FillPath() 
    VectorSourceColor(bgcol) 
    AddPathBox(0, 0, GadgetWidth(parent_canvas), GadgetHeight(parent_canvas))
    FillPath() 
    
    If fntcol = 0
      VectorSourceColor(RGBA(0,0,0,255))
    Else
      VectorSourceColor(fntcol)
    EndIf
    
    VectorFont(FontID(0),GadgetWidth(parent_canvas)/6.5) 
    text$ = StrF(value,decimals)
    MovePathCursor((GadgetWidth(parent_canvas)/2) - VectorTextWidth(text$)/2,(GadgetHeight(parent_canvas)/2) - (VectorTextHeight(text$)/2));
    DrawVectorText(text$)
    
    VectorFont(FontID(0),GadgetWidth(parent_canvas)/10) 
    text$ = units_text$
    MovePathCursor((GadgetWidth(parent_canvas)/2)- (VectorTextWidth(units_text$)/2), GadgetHeight(parent_canvas) - VectorTextHeight(units_text$) -GadgetHeight(parent_canvas)/12);)*(GadgetHeight(parent_canvas)/400)) - VectorTextHeight(units_text$));
    DrawVectorText(units_text$)
    
    If barcol = 0
      barcol = RGBA(0, 0, 0, 255)
    EndIf 
    
    Color32.q = barcol
    Color32 = Color32 & $FFFFFFFF 
    
    If Alpha(Color32) > 230
      VectorSourceColor(RGBA(Red(Color32), Green(Color32), Blue(Color32),  Alpha(Color32) - 220))
    EndIf
    
    start_angle.f = 0
    end_angle.f = 250
    steps.f = (end_angle - start_angle)/segments
    start.f = start_angle
    
    While start - 1 < end_angle 
      MovePathCursor(GadgetWidth(parent_canvas)/2 - (GadgetWidth(parent_canvas)/3), GadgetWidth(parent_canvas)/2)
      AddPathLine(GadgetWidth(parent_canvas)/12, GadgetWidth(parent_canvas)/2) 
      RotateCoordinates(GadgetWidth(parent_canvas)/2, GadgetWidth(parent_canvas)/2, steps)
      StrokePath(GadgetWidth(parent_canvas)/30,#PB_Path_RoundEnd)
      start = start + steps
    Wend 
    
    ResetCoordinates()
    VectorSourceColor(barcol)
    
    start = start_angle
    range_circle.f = end_angle - start_angle 
    
    If min < 0 And max < 0
      range_values = Abs(min) - Abs(max)
      actvalue.f = Abs(value) + Abs(min)
    ElseIf min < 0 And max >= 0
      range_values = max + Abs(min)   
      actvalue.f = value + Abs(min)
    ElseIf min >= 0 And max >= 0
      range_values = max - min  
      actvalue.f = value - min
    EndIf
    
    act_position.f = actvalue/range_values
    
    For i = 0 To (act_position*segments)
      MovePathCursor(GadgetWidth(parent_canvas)/2 - (GadgetWidth(parent_canvas)/3), GadgetWidth(parent_canvas)/2)
      AddPathLine(GadgetWidth(parent_canvas)/12, GadgetWidth(parent_canvas)/2) 
      RotateCoordinates(GadgetWidth(parent_canvas)/2, GadgetWidth(parent_canvas)/2, steps)
      StrokePath(GadgetWidth(parent_canvas)/30,#PB_Path_RoundEnd)
      start = start + steps
    Next
    
    ResetCoordinates()
    
    If iconimg <> - 1
      MovePathCursor(GadgetWidth(parent_canvas)/12, GadgetHeight(parent_canvas)/2 + GadgetWidth(parent_canvas)/12)
      ImageToColor(iconimg, fntcol)
      DrawVectorImage(ImageID(iconimg), 255, ImageWidth(iconimg)*(GadgetWidth(parent_canvas)/500), ImageHeight(iconimg)*(GadgetHeight(parent_canvas)/500))
      
    EndIf
    
    StopVectorDrawing()
  EndIf
EndProcedure

UsePNGImageDecoder()

gauge_height = 64

If OpenWindow(0, 0, 0,gauge_height*7 , gauge_height, "Mini Icon Gauges", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_SizeGadget)
  AddWindowTimer(0, 123, 500)
  LoadFont(0, "Verdana", 20,  #PB_Font_HighQuality); | #PB_Font_Bold
  LoadImage(0, #PB_Compiler_FilePath  + "/icons/weather.png")
  LoadImage(1, #PB_Compiler_FilePath  + "/icons/humidity.png")
  LoadImage(2, #PB_Compiler_FilePath  + "/icons/wind.png")
  LoadImage(3, #PB_Compiler_FilePath  + "/icons/barometer.png")
  
  CanvasGadget(10, 0, 0,WindowHeight(0),WindowHeight(0))
  CanvasGadget(11, WindowHeight(0), 0,WindowHeight(0),WindowHeight(0))
  CanvasGadget(12, WindowHeight(0)*2, 0,WindowHeight(0),WindowHeight(0))
  CanvasGadget(13, WindowHeight(0)*3, 0,WindowHeight(0),WindowHeight(0))
  CanvasGadget(14, WindowHeight(0)*4, 0,WindowHeight(0),WindowHeight(0))
  CanvasGadget(15, WindowHeight(0)*5, 0,WindowHeight(0),WindowHeight(0))
  CanvasGadget(16, WindowHeight(0)*6,0,WindowHeight(0),WindowHeight(0))
  
  Repeat
    
    If Event = #PB_Event_Timer And EventTimer() = 123
      draw_round_gauge_lined(10,Random(100,0)-50)
      draw_round_gauge_lined(11,(Random(500,0)-200)/10,"m/s",RGBA(165,42,42,255),2,0,RGBA(165,42,42,255),-20,30,1)
      draw_round_gauge_lined(12,Random(10300,9500)/10,"hPa",RGBA(0,128,128,255),3,0,RGBA(0,128,128,255),950, 1030,1)
      draw_round_gauge_lined(14,Random(10300,9500)/10,"hPa",0,3,0,RGBA(255,127,80,255),950, 1030,1)
      draw_round_gauge_lined(13,Random(1000,0)/10,"%",RGBA(153,50,204,255),1,0,0,0, 100,1)
      draw_round_gauge_lined(15,Random(300,0)/10,"°C",RGBA(15,15,15,255),0,RGBA(173,255,47,225),RGBA(15,15,15,255),0, 30,1)
      draw_round_gauge_lined(16,Random(300,0)/10,"°C",RGBA(173,255,47,255),0,RGBA(15,15,15,255),RGBA(173,255,47,255),0, 30,1)
    EndIf
    
    If event = #PB_Event_SizeWindow
      ResizeGadget(10, 0, 0, WindowHeight(0), WindowHeight(0))
      ResizeGadget(11, WindowHeight(0),0,  WindowHeight(0),WindowHeight(0))
      ResizeGadget(12, WindowHeight(0)*2,0,  WindowHeight(0),WindowHeight(0))
      ResizeGadget(13, WindowHeight(0)*3,0,  WindowHeight(0),WindowHeight(0))
      ResizeGadget(14, WindowHeight(0)*4,0,  WindowHeight(0),WindowHeight(0))
      ResizeGadget(15, WindowHeight(0)*5,0,  WindowHeight(0),WindowHeight(0))
      ResizeGadget(16, WindowHeight(0)*6, 0,WindowHeight(0),WindowHeight(0))
    EndIf
    
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf
; IDE Options = PureBasic 5.71 LTS (Windows - x64)
; CursorPosition = 108
; FirstLine = 96
; Folding = -
; EnableXP
; DPIAware